data:extend({
  {
	type = "item",
	name = "train-subscriber",
	icon = "__base__/graphics/icons/small-lamp.png",
	icon_size = 32,	
	flags = {"goes-to-quickbar"},
	subgroup = "transport",
	order = "a[train-system]-cb[train-subscriber]",
	place_result = "train-subscriber",
	stack_size = 50
  },
  {
	type = "lamp",
	name = "train-subscriber",
	icon = "__base__/graphics/icons/small-lamp.png",
	icon_size = 32,
	flags = {"placeable-neutral", "player-creation"},
	minable = {hardness = 0.2, mining_time = 0.5, result = "train-subscriber"},
	max_health = 100,
	corpse = "small-remnants",
	collision_box = {{-0.15, -0.15}, {0.15, 0.15}},
	selection_box = {{-0.5, -0.5}, {0.5, 0.5}},
	vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
	energy_source =
	{
	  type = "electric",
	  usage_priority = "secondary-input"
	},
	energy_usage_per_tick = "5KW",
	light = {intensity = 0.9, size = 2, color = {r=1.0, g=1.0, b=1.0}},
	light_when_colored = {intensity = 1, size = 2, color = {r=1.0, g=1.0, b=1.0}},
	glow_size = 2,
	glow_color_intensity = 0.135,
	picture_off =
	{
	  filename = "__base__/graphics/entity/small-lamp/light-off.png",
	  priority = "high",
	  width = 67,
	  height = 58,
	  frame_count = 1,
	  axially_symmetrical = false,
	  direction_count = 1,
	  shift = {-0.015625, 0.15625},
	},
	picture_on =
	{
	  filename = "__base__/graphics/entity/small-lamp/light-on-patch.png",
	  priority = "high",
	  width = 62,
	  height = 62,
	  frame_count = 1,
	  axially_symmetrical = false,
	  direction_count = 1,
	  shift = {-0.03125, -0.03125},
	},
	signal_to_color_mapping =
	{
	  {type="virtual", name="signal-red", color={r=1,g=0,b=0}},
	  {type="virtual", name="signal-green", color={r=0,g=1,b=0}},
	  {type="virtual", name="signal-blue", color={r=0,g=0,b=1}},
	  {type="virtual", name="signal-yellow", color={r=1,g=1,b=0}},
	  {type="virtual", name="signal-pink", color={r=1,g=0,b=1}},
	  {type="virtual", name="signal-cyan", color={r=0,g=1,b=1}},
	},

	circuit_wire_connection_point =
	{
	  shadow =
	  {
		red = {0.734375, 0.578125},
		green = {0.609375, 0.640625},
	  },
	  wire =
	  {
		red = {0.40625, 0.34375},
		green = {0.40625, 0.5},
	  }
	},
	-- circuit_connector_sprites = get_circuit_connector_sprites({0.1875, 0.28125}, {0.1875, 0.28125}, 18),
	circuit_wire_max_distance = 9

  },
  {
	type = "recipe",
	name = "train-subscriber",
	enabled = false,
	ingredients =
	{
		{"small-lamp", 1},
		{"advanced-circuit", 2}
	},
	result = "train-subscriber"
  },
  
  {
	type = "item",
	name = "train-publisher",
	icon = "__base__/graphics/icons/small-lamp.png",
	icon_size = 32,
	flags = {"goes-to-quickbar"},
	subgroup = "transport",
	order = "a[train-system]-cb[train-publisher]",
	place_result = "train-publisher",
	stack_size = 50
  },
  {
	type = "lamp",
	name = "train-publisher",
	icon = "__base__/graphics/icons/small-lamp.png",
	icon_size = 32,
	flags = {"placeable-neutral", "player-creation"},
	minable = {hardness = 0.2, mining_time = 0.5, result = "train-publisher"},
	max_health = 100,
	corpse = "small-remnants",
	collision_box = {{-0.15, -0.15}, {0.15, 0.15}},
	selection_box = {{-0.5, -0.5}, {0.5, 0.5}},
	vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
	energy_source =
	{
	  type = "electric",
	  usage_priority = "secondary-input"
	},
	energy_usage_per_tick = "5KW",
	light = {intensity = 0.9, size = 2, color = {r=1.0, g=1.0, b=1.0}},
	light_when_colored = {intensity = 1, size = 2, color = {r=1.0, g=1.0, b=1.0}},
	glow_size = 2,
	glow_color_intensity = 0.135,
	picture_off =
	{
	  filename = "__base__/graphics/entity/small-lamp/light-off.png",
	  priority = "high",
	  width = 67,
	  height = 58,
	  frame_count = 1,
	  axially_symmetrical = false,
	  direction_count = 1,
	  shift = {-0.015625, 0.15625},
	},
	picture_on =
	{
	  filename = "__base__/graphics/entity/small-lamp/light-on-patch.png",
	  priority = "high",
	  width = 62,
	  height = 62,
	  frame_count = 1,
	  axially_symmetrical = false,
	  direction_count = 1,
	  shift = {-0.03125, -0.03125},
	},
	signal_to_color_mapping =
	{
	  {type="virtual", name="signal-red", color={r=1,g=0,b=0}},
	  {type="virtual", name="signal-green", color={r=0,g=1,b=0}},
	  {type="virtual", name="signal-blue", color={r=0,g=0,b=1}},
	  {type="virtual", name="signal-yellow", color={r=1,g=1,b=0}},
	  {type="virtual", name="signal-pink", color={r=1,g=0,b=1}},
	  {type="virtual", name="signal-cyan", color={r=0,g=1,b=1}},
	},

	circuit_wire_connection_point =
	{
	  shadow =
	  {
		red = {0.734375, 0.578125},
		green = {0.609375, 0.640625},
	  },
	  wire =
	  {
		red = {0.40625, 0.34375},
		green = {0.40625, 0.5},
	  }
	},
--	circuit_connector_sprites = get_circuit_connector_sprites({0.1875, 0.28125}, {0.1875, 0.28125}, 18),
	circuit_wire_max_distance = 9

  },
  {
	type = "recipe",
	name = "train-publisher",
	enabled = false,
	ingredients =
	{
		{"small-lamp", 1},
		{"advanced-circuit", 2}
	},
	result = "train-publisher"
  },
  
  {
    type = "item",
    name = "train-counter",
    icon = "__base__/graphics/icons/constant-combinator.png",
	icon_size = 32,
    flags = { "goes-to-quickbar" },
    subgroup = "transport",
    place_result="train-counter",
    order = "a[train-system]-cb[train-counter]",
    stack_size= 50,
  },
  {
    type = "constant-combinator",
    name = "train-counter",
    icon = "__base__/graphics/icons/constant-combinator.png",
	icon_size = 32,
    flags = {"placeable-neutral", "player-creation"},
    minable = {hardness = 0.2, mining_time = 0.5, result = "train-counter"},
    max_health = 120,
    corpse = "small-remnants",

    collision_box = {{-0.35, -0.35}, {0.35, 0.35}},
    selection_box = {{-0.5, -0.5}, {0.5, 0.5}},

    item_slot_count = 18,

    sprites =
    make_4way_animation_from_spritesheet({ layers =
      {
        {
          filename = "__base__/graphics/entity/combinator/constant-combinator.png",
          width = 58,
          height = 52,
          frame_count = 1,
          shift = util.by_pixel(0, 5),
          hr_version =
          {
            scale = 0.5,
            filename = "__base__/graphics/entity/combinator/hr-constant-combinator.png",
            width = 114,
            height = 102,
            frame_count = 1,
            shift = util.by_pixel(0, 5),
          },
        },
        {
          filename = "__base__/graphics/entity/combinator/constant-combinator-shadow.png",
          width = 50,
          height = 34,
          frame_count = 1,
          shift = util.by_pixel(9, 6),
          draw_as_shadow = true,
          hr_version =
          {
            scale = 0.5,
            filename = "__base__/graphics/entity/combinator/hr-constant-combinator-shadow.png",
            width = 98,
            height = 66,
            frame_count = 1,
            shift = util.by_pixel(8.5, 5.5),
            draw_as_shadow = true,
          },
        },
      },
    }),

    -- {
      -- north =
      -- {
        -- filename = "__base__/graphics/entity/combinator/hr-constant-combinator.png",
        -- x = 158,
        -- y = 126,
        -- width = 79,
        -- height = 63,
        -- frame_count = 1,
        -- shift = {0.140625, 0.140625},
      -- },
      -- east =
      -- {
        -- filename = "__base__/graphics/entity/combinator/hr-constant-combinator.png",
        -- y = 126,
        -- width = 79,
        -- height = 63,
        -- frame_count = 1,
        -- shift = {0.140625, 0.140625},
      -- },
      -- south =
      -- {
        -- filename = "__base__/graphics/entity/combinator/hr-constant-combinator.png",
        -- x = 237,
        -- y = 126,
        -- width = 79,
        -- height = 63,
        -- frame_count = 1,
        -- shift = {0.140625, 0.140625},
      -- },
      -- west =
      -- {
        -- filename = "__base__/graphics/entity/combinator/hr-constant-combinator.png",
        -- x = 79,
        -- y = 126,
        -- width = 79,
        -- height = 63,
        -- frame_count = 1,
        -- shift = {0.140625, 0.140625},
      -- }
    -- },
activity_led_sprites =
  {
    north =
    {
      filename = "__base__/graphics/entity/combinator/activity-leds/constant-combinator-LED-N.png",
      width = 8,
      height = 6,
      frame_count = 1,
      shift = util.by_pixel(9, -12),
      hr_version =
      {
        scale = 0.5,
        filename = "__base__/graphics/entity/combinator/activity-leds/hr-constant-combinator-LED-N.png",
        width = 14,
        height = 12,
        frame_count = 1,
        shift = util.by_pixel(9, -11.5),
      },
    },
    east =
    {
      filename = "__base__/graphics/entity/combinator/activity-leds/constant-combinator-LED-E.png",
      width = 8,
      height = 8,
      frame_count = 1,
      shift = util.by_pixel(8, 0),
      hr_version =
      {
        scale = 0.5,
        filename = "__base__/graphics/entity/combinator/activity-leds/hr-constant-combinator-LED-E.png",
        width = 14,
        height = 14,
        frame_count = 1,
        shift = util.by_pixel(7.5, -0.5),
      },
    },
    south =
    {
      filename = "__base__/graphics/entity/combinator/activity-leds/constant-combinator-LED-S.png",
      width = 8,
      height = 8,
      frame_count = 1,
      shift = util.by_pixel(-9, 2),
      hr_version =
      {
        scale = 0.5,
        filename = "__base__/graphics/entity/combinator/activity-leds/hr-constant-combinator-LED-S.png",
        width = 14,
        height = 16,
        frame_count = 1,
        shift = util.by_pixel(-9, 2.5),
      },
    },
    west =
    {
      filename = "__base__/graphics/entity/combinator/activity-leds/constant-combinator-LED-W.png",
      width = 8,
      height = 8,
      frame_count = 1,
      shift = util.by_pixel(-7, -15),
      hr_version =
      {
        scale = 0.5,
        filename = "__base__/graphics/entity/combinator/activity-leds/hr-constant-combinator-LED-W.png",
        width = 14,
        height = 16,
        frame_count = 1,
        shift = util.by_pixel(-7, -15),
      },
    },
  },
    -- {
      -- north =
      -- {
        -- filename = "__base__/graphics/entity/combinator/activity-leds/constant-combinator-LED-N.png",
        -- width = 11,
        -- height = 10,
        -- frame_count = 1,
        -- shift = {0.296875, -0.40625},
      -- },
      -- east =
      -- {
        -- filename = "__base__/graphics/entity/combinator/activity-leds/constant-combinator-LED-E.png",
        -- width = 14,
        -- height = 12,
        -- frame_count = 1,
        -- shift = {0.25, -0.03125},
      -- },
      -- south =
      -- {
        -- filename = "__base__/graphics/entity/combinator/activity-leds/constant-combinator-LED-S.png",
        -- width = 11,
        -- height = 11,
        -- frame_count = 1,
        -- shift = {-0.296875, -0.078125},
      -- },
      -- west =
      -- {
        -- filename = "__base__/graphics/entity/combinator/activity-leds/constant-combinator-LED-W.png",
        -- width = 12,
        -- height = 12,
        -- frame_count = 1,
        -- shift = {-0.21875, -0.46875},
      -- }
    -- },

    activity_led_light =
    {
      intensity = 0.8,
      size = 1,
      color = {r = 1.0, g = 1.0, b = 1.0}
    },

    activity_led_light_offsets =
    {
      {0.296875, -0.40625},
      {0.25, -0.03125},
      {-0.296875, -0.078125},
      {-0.21875, -0.46875}
    },

    circuit_wire_connection_points =
    {
      {
        shadow =
        {
          red = {0.15625, -0.28125},
          green = {0.65625, -0.25}
        },
        wire =
        {
          red = {-0.28125, -0.5625},
          green = {0.21875, -0.5625},
        }
      },
      {
        shadow =
        {
          red = {0.75, -0.15625},
          green = {0.75, 0.25},
        },
        wire =
        {
          red = {0.46875, -0.5},
          green = {0.46875, -0.09375},
        }
      },
      {
        shadow =
        {
          red = {0.75, 0.5625},
          green = {0.21875, 0.5625}
        },
        wire =
        {
          red = {0.28125, 0.15625},
          green = {-0.21875, 0.15625}
        }
      },
      {
        shadow =
        {
          red = {-0.03125, 0.28125},
          green = {-0.03125, -0.125},
        },
        wire =
        {
          red = {-0.46875, 0},
          green = {-0.46875, -0.40625},
        }
      }
    },

    circuit_wire_max_distance = 9
  },
  
  {
	type = "recipe",
	name = "train-counter",
	enabled = false,
	ingredients =
	{
		{"small-lamp", 1},
		{"advanced-circuit", 2}
	},
	result = "train-counter"
  },

  {
    type = "virtual-signal",
    name = "train-counter",
    icon = "__base__/graphics/icons/diesel-locomotive.png",
	icon_size = 32,
    subgroup = "virtual-signal",
    order = "e[train-controller]-a[train-counter]"
  }
})